# coding: utf-8

"""
    Cobo Wallet as a Service 2.0

    Contact: help@cobo.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List
from typing import Optional, Set
from typing_extensions import Self


class BabylonAirdropPop(BaseModel):
    """
    Proof of Participation (PoP) details used for airdrop registration.
    """  # noqa: E501
    baby_address: StrictStr = Field(description="The Babylon (BABY) address used to receive BABY rewards.")
    btc_address: StrictStr = Field(description="The Bitcoin (BTC) address used for staking.")
    btc_public_key: StrictStr = Field(description="The public key corresponding to the `btc_address`, represented in hex format.")
    btc_sign_baby: StrictStr = Field(description="A BTC signature that signs the `baby_address`.")
    baby_sign_btc: StrictStr = Field(description="A BABY signature that signs the `btc_address`.")
    baby_public_key: StrictStr = Field(description="The public key corresponding to the `baby_address`, represented in base64 format.")
    __properties: ClassVar[List[str]] = ["baby_address", "btc_address", "btc_public_key", "btc_sign_baby", "baby_sign_btc", "baby_public_key"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of BabylonAirdropPop from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of BabylonAirdropPop from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "baby_address": obj.get("baby_address"),
            "btc_address": obj.get("btc_address"),
            "btc_public_key": obj.get("btc_public_key"),
            "btc_sign_baby": obj.get("btc_sign_baby"),
            "baby_sign_btc": obj.get("baby_sign_btc"),
            "baby_public_key": obj.get("baby_public_key")
        })
        return _obj


