# coding: utf-8

"""
    Cobo Wallet as a Service 2.0

    Contact: help@cobo.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from cobo_waas2.models.amount_status import AmountStatus
from typing import Optional, Set
from typing_extensions import Self


class EthStakingExtraAllOfBeaconValidators(BaseModel):
    """
    EthStakingExtraAllOfBeaconValidators
    """  # noqa: E501
    pubkey: Optional[StrictStr] = Field(default=None, description="The public key of the validator.")
    status: Optional[AmountStatus] = None
    apy: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="The annual percentage yield (APY) of the validator.")
    staked_amount: Optional[StrictStr] = Field(default=None, description="The staked amount.")
    rewards_received: Optional[StrictStr] = Field(default=None, description="The rewards received.")
    updated_timestamp: Optional[StrictInt] = Field(default=None, description="The time when the validator's status was last updated, in Unix timestamp format and measured in milliseconds.")
    __properties: ClassVar[List[str]] = ["pubkey", "status", "apy", "staked_amount", "rewards_received", "updated_timestamp"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of EthStakingExtraAllOfBeaconValidators from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of EthStakingExtraAllOfBeaconValidators from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "pubkey": obj.get("pubkey"),
            "status": obj.get("status"),
            "apy": obj.get("apy"),
            "staked_amount": obj.get("staked_amount"),
            "rewards_received": obj.get("rewards_received"),
            "updated_timestamp": obj.get("updated_timestamp")
        })
        return _obj


